
###############################################################################
### Nest abund site-by-site formulation, Gaussian distribution of entry date
###############################################################################

GAU_robel <- function(mname='Phi(robel)P(robel)GAU',theta_init=NULL) {

### Log-likelihood Full Model Phi(Site+Stage+Cattle+Robel)P(Site+Stage+Cattle+Robel)
LOGLIK00 <- function(theta1) {
  theta=thta.fn(theta1)
  i=1; thet_moy_ageday1=theta[i]
  i=i+1; thet_sd_ageday1=abs(theta[i])
  thet_phi_site     =theta[i+1:NS]
  i=i+NS+1; thet_phi_Stage  =theta[i]
  i=i+1; thet_phi_Cattle  =theta[i]
  i=i+1; thet_phi_Robel  =theta[i]
  thet_p_site    =theta[i+1:NS]
  i=i+NS+1; thet_p_Stage    =theta[i]
  i=i+1; thet_p_Cattle  =theta[i]
  i=i+1; thet_p_Robel  =theta[i]
  thet_N          =CC+exp(theta[i+1:NS])
  i=i+NS; thet_pi_Cattle  =plogis(theta[i+1:NS])
  i=i+NS+1; thet_moy_Robel  =theta[i]
  i=i+1; thet_sd_Robel=theta[i]

  ### Compute probability of capture-recapture data  (Pdata)
  #--------------------------------------------------
  Pdata=ll00(theta1); #cat('>pdata:',Pdata,'\n')
  ### Probability of missing a carcass (Gauss Hermite quadrature)
  #--------------------------------------------------
  thet=list(
    moy_ageday1 = thet_moy_ageday1,
    sd_ageday1  = thet_sd_ageday1,
    phi_site    = thet_phi_site,
    phi_Stage   = thet_phi_Stage,
    phi_Cattle  = thet_phi_Cattle,
    phi_Robel   = thet_phi_Robel,
    p_site      = thet_p_site,
    p_Stage     = thet_p_Stage,
    p_Cattle    = thet_p_Cattle,
    p_Robel     = thet_p_Robel,
    N           = thet_N,
    pi_Cattle   = thet_pi_Cattle,
    moy_Robel   = thet_moy_Robel,
    sd_Robel    = thet_sd_Robel)

  P0=compute_P0(thet)

  logLIK=Pdata-sum(lfactorial(thet_N)-lfactorial(thet_N-CC)+(thet_N-CC)*log(P0))

  setTkProgressBar(pb,value=iternum,label=paste("Optimization",opt.fn+1,"...",iternum,
     round(logLIK,3),"\nP0=", paste(round(P0,3),collapse=' '), "\nN=",
     paste(round(thet_N,2),collapse=' ')))
  return(logLIK)

}  # end definition LOGLIKsPs

### Log-likelihood using observed data only
ll00 <- function(theta1) { theta=thta.fn(theta1)
  i=1;   thet_moy_ageday1=theta[i]
  i=i+1; thet_sd_ageday1 =abs(theta[i])
  thet_phi_site     =theta[i+1:NS]
  i=i+NS+1; thet_phi_Stage  =theta[i]
  i=i+1; thet_phi_Cattle  =theta[i]
  i=i+1; thet_phi_Robel  =theta[i]
  thet_p_site    =theta[i+1:NS]
  i=i+NS+1; thet_p_Stage    =theta[i]
  i=i+1; thet_p_Cattle  =theta[i]
  i=i+1; thet_p_Robel  =theta[i]
  thet_N          =CC+exp(theta[i+1:NS])
  i=i+NS; thet_pi_Cattle  =plogis(theta[i+1:NS])
  i=i+NS+1; thet_moy_Robel  =theta[i]
  i=i+1; thet_sd_Robel  =theta[i]
  Pdata <- 0
  # initiate matrices
  thet_phiDaily=rep(0,daymax); thet_p=rep(0,max(NT)); thet_phi=rep(0,max(NT)-1)
  ### Compute probability of capture-recapture data  (Pdata)
  #--------------------------------------------------
  t3=rep(0,C1)
  if (ContCovCol>0) t3=log(dnorm(robel.data,thet_moy_Robel,thet_sd_Robel))
  for ( k in 1:C1) {
    sitek=Site[k]; TT=NT[sitek]; Lday <- DaySampl[sitek,NT[sitek]] ## Last day of study for this site
    FF=xdata$FirstFound[k]; LP=xdata$LastPresent[k] ; AF = xdata$AgeFound[k]
    # Daily survival
    t=ek[k]:Lday  ## GP290713
    thet_phiDaily=plogis(thet_phi_site[sitek]+
      thet_phi_Stage*(t>=DayStartIncub[k])+
      thet_phi_Cattle*cattle.data[k]+
      thet_phi_Robel*robel.data[k])
    # Detection
    t=1:NT[sitek]; thet_p[t] = plogis(thet_p_site[sitek] +
      thet_p_Stage*(t<psik[k])+
      thet_p_Cattle*cattle.data[k]+
      thet_p_Robel*robel.data[k])
    ## Probability of detecting nest on fk[k]th visit
    if(AF<=1) Pfk=thet_p[fk[k]] else Pfk=prod(thet_phiDaily[1:(AF-1)])*thet_p[fk[k]] ## GP290713
    if (fk[k] > bk[k]) Pfk=Pfk*prod(1-thet_p[bk[k]:(fk[k]-1)])
    ## Probability of nest survival data
    ###1 if successful nest or fails after last occ
    if (xdata$Fate[k] == 0 || xdata$LastPresent[k]>=Lday) {
        PSk <- prod(thet_phiDaily[AF:(min(Hk[k],Lday)-ek[k])])
    } else {
    ###2 if failed nest
      llast <- min(Hk[k], LP, Lday)
      llast2<-lastocc(llast,sitek)
      if (llast2<NT[sitek]) {
        d1=DaySampl[sitek,llast2];
        d2=max(d1,DaySampl[sitek,(llast2+1)]-1)
        thet_phi = prod(thet_phiDaily[d1:d2-ek[k]+1])   ## GP290713
        PSk=1-thet_phi
      } else {PSk=1} # GP20082013
      if (llast>FF) {
        PSk=PSk*prod(thet_phiDaily[AF:(llast-ek[k])]);
      }
    }
    t1=log(max(dnorm(xdata$AgeDay1[k],thet_moy_ageday1,thet_sd_ageday1),1e-6))
    t2=log(thet_pi_Cattle[sitek]*cattle.data[k]+(1-thet_pi_Cattle[sitek])*(1-cattle.data[k]))
    Pdata <- Pdata - log(Pfk) - log(PSk)- t1 - t2 - t3[k]
   }  # end loop on individual nests
  logLIK=Pdata;
  iternum<<-iternum+1 ;
  if (opt.fn==0)
    setTkProgressBar(pb,value=iternum,label=paste("Optimization1...",iternum,round(logLIK,3)))
  return(logLIK)
}  # end definition LOGLIKsPs

##############################################################################
# P0
##############################################################################
#-- When fixing continuous cov to its mean  [returns a NS size vector]
### NB: if there is no use of the continuous cov (Robel),
### then use only this function to compute P0 (divides computation time by Q)
compute_P0MOY<- function(thet) {
  P0=NULL
  for (s in 1:NS) {  Q0=0
    for (q in 1:Q) {
      tmp=
       P0e(thet,1-(thet$sd_ageday1*sqrt(2)*zGH[q]+thet$moy_ageday1),
           s,thet$moy_Robel)
      Q0=Q0+wGH[q]*tmp
    }
    P0=c(P0,min(Q0/sqrt(3.14159265),1))
  }

  return(P0)
}
#-- When integrating over cov values (GH quad) [returns a NS size vector]
compute_P0INT <- function(thet) {
  P0=NULL
  for (s in 1:NS) {  Q0=0
    for (q in 1:Q) {
      for (qprime in 1:Q) {
        tmp=
         P0e(thet,1-(thet$sd_ageday1*sqrt(2)*zGH[q]+thet$moy_ageday1),
            s,thet$sd_Robel*sqrt(2)*zGH[qprime]+thet$moy_Robel)
        Q0=Q0+wGH[q]*wGH[qprime]*tmp
      }
    }
    P0=c(P0,min(Q0/(3.14159265),1))
  }
  #cat('>>P0=',P0,'\n')
  return(P0)
}
#-- Fixed entry date, site, and cov value
P0e<- function(thet,e,s,r) {
  HatchDate= e+INCUBLEN  # expected hatch date =34 in paper
  DayStartIncub1 = e + AvgClutch # expected start of incubation
  InitDate=max(e,1)  # initiation date or start of study
  psi = lastocc(DayStartIncub1,s) # last occasion before incubation start
  Lday <- DaySampl[s,NT[s]]
  HatchDate2 <- min(HatchDate,Lday)
  if(HatchDate<1 || e>Lday) {return(1)} else{
    d=HatchDate;  t=birthocc(e,s):lastocc(d,s)
           #-- conditional on nest success * Pr(success)
         #  Q0=P0eSucc(theta,e,s,0,r);  Q1=P0eSucc(theta,e,s,1,r)
    thet_p0 = plogis(thet$p_site[s] + thet$p_Stage*(t<psi)+thet$p_Robel*r )
    thet_p1 = plogis(thet$p_site[s] + thet$p_Stage*(t<psi)+
             thet$p_Cattle + thet$p_Robel*r )
    t=e:(d-1)
    thet_phiDaily0 = plogis(thet$phi_site[s] + thet$phi_Stage*(t>=DayStartIncub1)+
          thet$phi_Robel*r)
    thet_phiDaily1= plogis(thet$phi_site[s] + thet$phi_Stage*(t>=DayStartIncub1)+
          thet$phi_Cattle + thet$phi_Robel*r)
    tmp=d>e
    if(d>=1 && e<=Lday) {
      Q0=prod(1-thet_p0)*(tmp*prod(thet_phiDaily0) +1-tmp)
      Q1=prod(1-thet_p1)*(tmp*prod(thet_phiDaily1) +1-tmp)
    }

    for (d in e:HatchDate2) { #-- conditional on failure at d * Pr(d)
      #Q0=Q0+P0ed(thet,e,d,s,0,r); Q1=Q1+P0ed(thet,e,d,s,1,r)
      t=birthocc(e,s):lastocc(d,s)
      thet_p0 = plogis(thet$p_site[s] + thet$p_Stage*(t<psi)+thet$p_Robel*r )
      thet_p1 = plogis(thet$p_site[s] + thet$p_Stage*(t<psi)+
               thet$p_Cattle+ thet$p_Robel*r )
      t=e:d
      thet_phiDaily0 = plogis(thet$phi_site[s] + thet$phi_Stage*(t>=DayStartIncub1)+
            thet$phi_Robel*r)
      thet_phiDaily1 = plogis(thet$phi_site[s] + thet$phi_Stage*(t>=DayStartIncub1)+
            thet$phi_Cattle+ thet$phi_Robel*r)
      ll=length(thet_phiDaily0); tmp=ll>1
      prphi0<- tmp*prod(thet_phiDaily0[1:max((ll-1),1)]) +1-tmp
      prphi1<- tmp*prod(thet_phiDaily1[1:max((ll-1),1)]) +1-tmp
      phid0<- thet_phiDaily0[ll]; phid1<- thet_phiDaily1[ll]

      v0=prphi0*(1-phid0); v1=prphi1*(1-phid1)
      if(d>=1 && e<=Lday) {
        v0=prod(1-thet_p0)*prphi0*(1-phid0); v1=prod(1-thet_p1)*prphi1*(1-phid1)
      }
      Q0=Q0+v0; Q1=Q1+v1
    }
    v=thet$pi_Cattle[s]*Q1 + (1-thet$pi_Cattle[s])*Q0;
    return(v)
  }
}#END P0######################################################

 cat('Fixed and Initial values:\n\n')
v1<-c(
  "Mean AgeDay1","SD AgeDay1",
  paste("Survival: site",1:NS),
  "Survival: Stage",
  "Survival: Cattle",
  "Survival: Robel",
  paste("Detection: site",1:NS),
  "Detection: Stage" ,
  "Detection: Cattle",
  "Detection: Robel",
  paste('Superpop. size:Site',1:NS),
  paste("Prop. Cattle site",1:NS),
  "moy Robel", "SD Robel"
  )
v2<-c(
  "Mean AgeDay1","SD AgeDay1",
  paste("Survival:Egg:NoCattle:Site",1:NS),
  paste("Survival:Incub:NoCattle:Site",1:NS),
  paste("Survival:Egg:Cattle:Site",1:NS),
  paste("Survival:Incub:Cattle:Site",1:NS),
  paste("Detection:Egg:NoCattle:Site",1:NS),
  paste("Detection:Incub:NoCattle:Site",1:NS),
  paste("Detection:Egg:Cattle:Site",1:NS),
  paste("Detection:Incub:Cattle:Site",1:NS),
  paste('Superpop. size:Site',1:NS),
  paste('P0:Site',1:NS),
  "Survival:Robel","Detection:Robel"
  )
  if (nchar(BinCovName)>0) { v1=gsub("Cattle",BinCovName,v1); v2=gsub("Cattle",BinCovName,v2)}
  if (nchar(ContCovName)>0) { v1=gsub("Robel",ContCovName,v1); v2=gsub("Robel",ContCovName,v2)}
  iternum<<-0 ; opt.fn<<-0; maxitr=3000
  x=table(xdata$Site,xdata$Site);
  if (nchar(BinCovName)>0)
    if (BinCovName!="NA") x=table(cattle.data,xdata$Site)
  v=qlogis(x[2,]/colSums(x));  v[v<(-40)]=-40; v[v>40]=40;

  mname2pim(mname,v1)

  l=max(pim); pb=tkProgressBar(mname,min=1,max=3000)

  if (is.null(theta_init)) {
    theta_init = rep(0,l)
    theta_init[1]<-mean(xdata$AgeDay1); theta_init[2]<-sd(xdata$AgeDay1);
  }  else {
    theta_init = thta.fn.inv(theta_init)  #  init values must have length=v1
  }
  theta_init[is.na(theta_init)]=0; l=length(theta_init)
  if (theta_init[l]==0 && ContCovCol>0) {
    theta_init[l-1]<-mean(robel.data); theta_init[l]<-sd(robel.data)
  }
  if (thta.fn(theta_init)[length(v1)-2-NS+1]==0) theta_init[pim[length(v1)-2-NS+1:NS]]=v

  x=cbind(v1,pim,fixed,thta.fn(theta_init));
  dimnames(x)=list(NULL,c('parm','pim','fixed','init.val'));
  print(x,quote=F); cat('\nRunning optimization...\n')
  iternum<<-0; t0=system.time(s0<-nlm(ll00,theta_init, hessian = FALSE,iterlim=maxitr));

  compute_P0<-compute_P0MOY; opt.fn<<-1

  t1=system.time(ssMOY <- nlm(LOGLIK00,s0$estimate, hessian = TRUE,iterlim=maxitr))
  ss1=ssMOY; t2=0
  tMOY<-ssMOY$estimate;
  if (length(grep('robel',mname))>0) {
    compute_P0<-compute_P0INT
    iternum<<-0; opt.fn<<-2
    t2=system.time(ss1 <- nlm(LOGLIK00,tMOY, hessian = TRUE,iterlim=maxitr))
  }
  save(ss1,file=paste('nest_abund_',mname,'.rdata',sep=''))
  close(pb)

  thetaM=ss1$estimate; theta=thta.fn(thetaM); l=length(ss1$estimate)
  i=1; thet_moy_ageday1=theta[i]
  i=i+1; thet_sd_ageday1=abs(theta[i])
  thet_phi_site     =theta[i+1:NS]
  i=i+NS+1; thet_phi_Stage  =theta[i]
  i=i+1; thet_phi_Cattle  =theta[i]
  i=i+1; thet_phi_Robel  =theta[i]
  thet_p_site    =theta[i+1:NS]
  i=i+NS+1; thet_p_Stage    =theta[i]
  i=i+1; thet_p_Cattle  =theta[i]
  i=i+1; thet_p_Robel  =theta[i]
  thet_N          =CC+exp(theta[i+1:NS])
  i=i+NS; thet_pi_Cattle  =plogis(theta[i+1:NS])
  i=i+NS+1; thet_moy_Robel  =theta[i]
  i=i+1; thet_sd_Robel  =theta[i]
  thet=list(moy_ageday1=thet_moy_ageday1,sd_ageday1=thet_sd_ageday1,
     phi_site=thet_phi_site,phi_Stage=thet_phi_Stage,
     phi_Cattle=thet_phi_Cattle,phi_Robel=thet_phi_Robel,
     p_site=thet_p_site,p_Stage=thet_p_Stage,
     p_Cattle=thet_p_Cattle, p_Robel=thet_p_Robel,
     N=thet_N,pi_Cattle=thet_pi_Cattle,moy_Robel=thet_moy_Robel,sd_Robel=thet_sd_Robel)
  P0=compute_P0(thet)

# -- start manipulation of hessian
SIGtheta <- ginv(ss1$hessian)
if(min(Re(eigen(SIGtheta)$values))<=0) {
  cat('***inverse of hessian has negative eigenvalue...\n')
  cat('     using decomposition and rounding error correction\n')
  SIGtheta <- ginv(ss1$hessian+diag(max(-eigen(ss1$hessian)$values,0),l))+diag(1e-6,l)
}
e <- eigen(SIGtheta); V <- e$vectors
B <- V %*% diag(sqrt(e$values)) %*% t(V)
SIGtheta <- Re(B %*% t(B))
# -- end manipulation of hessian

# Compute transformed estimates
  xest<- c(
    thet_moy_ageday1,thet_sd_ageday1,
    plogis(thet_phi_site+thet_phi_Robel*thet_moy_Robel),
    plogis(thet_phi_site+thet_phi_Stage+thet_phi_Robel*thet_moy_Robel),
    plogis(thet_phi_site+thet_phi_Cattle+thet_phi_Robel*thet_moy_Robel),
    plogis(thet_phi_site+thet_phi_Stage+thet_phi_Cattle+thet_phi_Robel*thet_moy_Robel),
    plogis(thet_p_site+thet_p_Stage+thet_p_Robel*thet_moy_Robel),
    plogis(thet_p_site+thet_p_Robel*thet_moy_Robel),
    plogis(thet_p_site+thet_p_Stage+thet_p_Cattle+thet_p_Robel*thet_moy_Robel),
    plogis(thet_p_site+thet_p_Cattle+thet_p_Robel*thet_moy_Robel),
    thet_N, P0 , thet_phi_Robel,thet_p_Robel
  )

# Bootstrap
cat('\nRunning bootstrap...\n')
x_boot=matrix(0,UUU,length(xest))
for (uuu in 1:UUU) {      #setTkProgressBar(pb,label="Boostrap...",500+uuu)
  #  draw from multivariate distribution
  #--------------------------------------------------
  theta1=rmvnorm(1,mean=thetaM,sigma=SIGtheta); theta=thta.fn(theta1)
  i=1; thet_moy_ageday1=theta[i]; i=i+1; thet_sd_ageday1=abs(theta[i])
  thet_phi_site     =theta[i+1:NS]
  i=i+NS+1; thet_phi_Stage  =theta[i]
  i=i+1; thet_phi_Cattle  =theta[i]
  i=i+1; thet_phi_Robel  =theta[i]
  thet_p_site    =theta[i+1:NS]
  i=i+NS+1; thet_p_Stage    =theta[i]
  i=i+1; thet_p_Cattle  =theta[i]
  i=i+1; thet_p_Robel  =theta[i]
  thet_N          =CC+exp(theta[i+1:NS])
  i=i+NS; thet_pi_Cattle  =plogis(theta[i+1:NS])
  i=i+NS+1; thet_moy_Robel =theta[i];  i=i+1; thet_sd_Robel  =theta[i]
  thet=list(moy_ageday1=thet_moy_ageday1,sd_ageday1=thet_sd_ageday1,
     phi_site=thet_phi_site,phi_Stage=thet_phi_Stage,
     phi_Cattle=thet_phi_Cattle,phi_Robel=thet_phi_Robel,
     p_site=thet_p_site,p_Stage=thet_p_Stage,
     p_Cattle=thet_p_Cattle, p_Robel=thet_p_Robel,
     N=thet_N,pi_Cattle=thet_pi_Cattle,
     moy_Robel=thet_moy_Robel, sd_Robel=thet_sd_Robel)
  P0=compute_P0(thet)
  x_boot[uuu,]<- c(
    thet_moy_ageday1,thet_sd_ageday1,
    plogis(thet_phi_site+thet_phi_Stage+thet_phi_Robel*thet_moy_Robel),
    plogis(thet_phi_site+thet_phi_Robel*thet_moy_Robel),
    plogis(thet_phi_site+thet_phi_Stage+thet_phi_Cattle+thet_phi_Robel*thet_moy_Robel),
    plogis(thet_phi_site+thet_phi_Cattle+thet_phi_Robel*thet_moy_Robel),
    plogis(thet_p_site+thet_p_Robel*thet_moy_Robel),
    plogis(thet_p_site+thet_p_Stage+thet_p_Robel*thet_moy_Robel),
    plogis(thet_p_site+thet_p_Cattle+thet_p_Robel*thet_moy_Robel),
    plogis(thet_p_site+thet_p_Stage+thet_p_Cattle+thet_p_Robel*thet_moy_Robel),
    thet_N, P0 , thet_phi_Robel,thet_p_Robel
  )
}

#Display
cat('\n\n###################### RESULTS ################################\n\n')
cat('Untransformed estimates\n')
thetaM=thta.fn(thetaM); betase=thta.fn(sqrt(diag(SIGtheta)))
tabun<-cbind(thetaM,thetaM-1.96*betase,thetaM+1.96*betase,pim,fixed)
dimnames(tabun) <- list(v1,c('estimate','95%CI low','95%CI upp','pim','fixed'))
print(round(tabun,3))
cat('\nTransformed estimates\n')
lowb<-apply(X=x_boot, MARGIN=2, FUN =CIlow)
uppb<-apply(X=x_boot, MARGIN=2, FUN =CIhigh)
tab<-cbind(xest,lowb,uppb)
dimnames(tab) <- list(v2,c('estimate','95%CI low','95%CI upp'))
print(round(tab,3))
cat('\nfinal LogLike     =',-ss1$minimum,'\n')
cat('number of parameters=',length(theta_init),'\n')
cat('AIC                 =',2*ss1$minimum+2*length(theta_init),'\n\n')
tt=sum(c(t0[1],t1[1],t2[1]))
cat('cpu time:',round(tt/60,1),'minutes\n')
#cat('completion code:',ss1$code,' iterations:',ss1$iterations,'\n')
save(tab,tabun,ss1,ssMOY,s0,file=paste('nest_abund_',mname,'.rdata',sep=''))
names(ss1$estimate)=v1[unique(pim)]
x=names(ss1); ss1[[length(ss1)+1]]=tab; names(ss1)=c(x,'tab')
return(ss1)
}